package mr

//
// RPC definitions.
//
// remember to capitalize all names.
//

import (
	"os"
	"strconv"
)

//
// example to show how to declare the arguments
// and reply for an RPC.
//

type ExampleArgs struct {
	X int
}

type ExampleReply struct {
	Y int
}

// Add your RPC definitions here.

type State int

const (
	IDLE State = iota
	PROGRESS
	COMPELETED
)

type TaskType int

const (
	TASK_IDLE TaskType = iota
	TASK_MAP
	TASK_REDUCE
	TASK_DONE
)

type Task struct {
	TaskType   TaskType
	MapTask    *MapTask
	ReduceTask *ReduceTask
}

type MapTask struct {
	Fname     string
	State     State
	NReduce   int
	TaskId    int
	MachineId int
}

type ReduceTask struct {
	Fnames    []string
	State     State
	MachineId int
	TaskId    int
}

type Empty struct {
}

// Cook up a unique-ish UNIX-domain socket name
// in /var/tmp, for the coordinator.
// Can't use the current directory since
// Athena AFS doesn't support UNIX-domain sockets.
func coordinatorSock() string {
	s := "/var/tmp/5840-mr-"
	s += strconv.Itoa(os.Getuid())
	return s
}
